package xcom.thoughtworks.xstream.io.xml;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;

import java.io.ByteArrayInputStream;
import java.io.IOException;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.junit.Test;
import org.w3c.dom.Document;
import org.xml.sax.SAXException;

import xcom.thoughtworks.xstream.io.HierarchicalStreamReader;
import xcom.thoughtworks.xstream.io.xml.DomReader;
import xcom.thoughtworks.xstream.io.xml.XmlFriendlyNameCoder;

public class XMLFNCCumulativeTS_mujava3 {

	public String test_1() {
		try {

			String dollarReplacement = "_-";
			String escapeCharReplacement = "^-";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			ncoder.decodeNode("A^-Node");

			return ncoder.decodeNode("A^-Node");

		} catch (Exception ex) {
			return ex.toString();
		}
	}

	public String test_1_1() {
		try {

			String dollarReplacement = "_-";
			String escapeCharReplacement = "^-";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			ncoder.decodeNode("A^Node");

			return ncoder.decodeNode("A^Node");

		} catch (Exception ex) {
			return ex.toString();
		}
	}

	public String test_2() {
		try {

			String dollarReplacement = "_-";
			String escapeCharReplacement = "^-";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			ncoder.decodeNode("_-Node");

			return ncoder.decodeNode("_-Node");

		} catch (Exception ex) {
			return ex.toString();
		}
	}

	public String test_2_2() {
		try {

			String dollarReplacement = "_-";
			String escapeCharReplacement = "^-";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			ncoder.decodeNode("_Node");

			return ncoder.decodeNode("_Node");

		} catch (Exception ex) {
			return ex.toString();
		}
	}

	public String test_3() {
		try {

			String dollarReplacement = "_-";
			String escapeCharReplacement = "^-";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			ncoder.decodeNode("ANode");

			return ncoder.decodeNode("ANode");

		} catch (Exception ex) {
			return ex.toString();
		}
	}

	public String test_111111() {
		try {

			String dollarReplacement = "--";
			String escapeCharReplacement = "_-";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			ncoder.decodeNode("--Node");

			return ncoder.decodeNode("--Node");

		} catch (Exception ex) {
			return ex.toString();
		}
	}

	public String test_1_111111() {
		try {

			String dollarReplacement = "--";
			String escapeCharReplacement = "_-";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			ncoder.decodeNode("Another-Node");

			return ncoder.decodeNode("Another-Node");

		} catch (Exception ex) {
			return ex.toString();
		}
	}

	public String test_211111() {
		try {

			String dollarReplacement = "--";
			String escapeCharReplacement = "_-";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			ncoder.decodeNode("Another_-Node");

			return ncoder.decodeNode("Another_-Node");

		} catch (Exception ex) {
			return ex.toString();
		}
	}

	public String test_2_21111() {
		try {

			String dollarReplacement = "--";
			String escapeCharReplacement = "_-";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			ncoder.decodeNode("Another_Node");

			return ncoder.decodeNode("Another_Node");

		} catch (Exception ex) {
			return ex.toString();
		}
	}

	public String test_31111() {
		try {

			String dollarReplacement = "_-";
			String escapeCharReplacement = "^-";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			ncoder.decodeNode("ANode");

			return ncoder.decodeNode("ANode");

		} catch (Exception ex) {
			return ex.toString();
		}
	}

	public String test_11111() {
		try {

			String dollarReplacement = "!-";
			String escapeCharReplacement = "_!";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			ncoder.decodeNode("Yanother!-Node");

			return ncoder.decodeNode("Yanother!-Node");

		} catch (Exception ex) {
			return ex.toString();
		}
	}

	public String test_1_11111() {
		try {

			String dollarReplacement = "!-";
			String escapeCharReplacement = "_-";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			ncoder.decodeNode("Another!Node");

			return ncoder.decodeNode("Another!Node");

		} catch (Exception ex) {
			return ex.toString();
		}
	}

	public String test_21111() {
		try {

			String dollarReplacement = "!-";
			String escapeCharReplacement = "_!";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			ncoder.decodeNode("_!Node");

			return ncoder.decodeNode("_!Node");

		} catch (Exception ex) {
			return ex.toString();
		}
	}

	public String test_2_2111() {
		try {

			String dollarReplacement = "--";
			String escapeCharReplacement = "!-";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			ncoder.decodeNode("Another!Node");

			return ncoder.decodeNode("Another!Node");

		} catch (Exception ex) {
			return ex.toString();
		}
	}

	public String test_3111() {
		try {

			String dollarReplacement = "_-";
			String escapeCharReplacement = "^-";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			ncoder.decodeNode("ANode");

			return ncoder.decodeNode("ANode");

		} catch (Exception ex) {
			return ex.toString();
		}
	}

	public String test_1111() {
		try {

			String dollarReplacement = "!-_";
			String escapeCharReplacement = "_!-";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			ncoder.decodeNode("Node!-_");

			return ncoder.decodeNode("Node!-_");

		} catch (Exception ex) {
			return ex.toString();
		}
	}

	public String test_1_1111() {
		try {

			String dollarReplacement = "!-_";
			String escapeCharReplacement = "_!-";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			ncoder.decodeNode("Node!");

			return ncoder.decodeNode("Node!");

		} catch (Exception ex) {
			return ex.toString();
		}
	}

	public String test_2111() {
		try {

			String dollarReplacement = "!-_";
			String escapeCharReplacement = "_!_";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			ncoder.decodeNode("_!_Node");

			return ncoder.decodeNode("_!_Node");

		} catch (Exception ex) {
			return ex.toString();
		}
	}

	public String test_2_211() {
		try {

			String dollarReplacement = "---";
			String escapeCharReplacement = "!--";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			ncoder.decodeNode("Another!");

			return ncoder.decodeNode("Another!");

		} catch (Exception ex) {
			return ex.toString();
		}
	}

	public String test_311() {
		try {

			String dollarReplacement = "_-";
			String escapeCharReplacement = "^-";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			ncoder.decodeNode("ANode");

			return ncoder.decodeNode("ANode");

		} catch (Exception ex) {
			return ex.toString();
		}
	}

	public String test_11() {
		try {

			String dollarReplacement = "^^";
			String escapeCharReplacement = "_!-";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			ncoder.decodeNode("^^Node");

			return ncoder.decodeNode("^^Node");

		} catch (Exception ex) {
			return ex.toString();
		}
	}

	public String test_1_11() {
		try {

			String dollarReplacement = "^^";
			String escapeCharReplacement = "_!-";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			ncoder.decodeNode("^N^ode");

			return ncoder.decodeNode("^N^ode");

		} catch (Exception ex) {
			return ex.toString();
		}
	}

	public String test_21() {
		try {

			String dollarReplacement = "!-_";
			String escapeCharReplacement = "!!";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			ncoder.decodeNode("!!Node");

			return ncoder.decodeNode("!!Node");

		} catch (Exception ex) {
			return ex.toString();
		}
	}

	public String test_2_21() {
		try {

			String dollarReplacement = "-_";
			String escapeCharReplacement = "!!";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			ncoder.decodeNode("a!Node");

			return ncoder.decodeNode("a!Node");

		} catch (Exception ex) {
			return ex.toString();
		}
	}

	public String test_31() {
		try {

			String dollarReplacement = "_-";
			String escapeCharReplacement = "^-";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			ncoder.decodeNode("ANode");

			return ncoder.decodeNode("ANode");

		} catch (Exception ex) {
			return ex.toString();
		}
	}

	@Test
	public String test_111() {
		try {
			XmlFriendlyNameCoder nameCoder = new XmlFriendlyNameCoder();
			return nameCoder.decodeNode("test");
		} catch (Exception ex) {
			return ex.toString();
		}
	}

	@Test
	public String test_211() {
		try {
			XmlFriendlyNameCoder nameCoder = new XmlFriendlyNameCoder("_-", "*_");
			return nameCoder.decodeNode("t*_est");
		} catch (Exception ex) {
			return ex.toString();
		}
	}

	@Test
	public String test_311111() {
		try {
			XmlFriendlyNameCoder nameCoder = new XmlFriendlyNameCoder("_-", "*_");
			return nameCoder.decodeNode("_-te*_st");
		} catch (Exception ex) {
			return ex.toString();
		}
	}

	@Test
	public String test_4() {
		try {
			XmlFriendlyNameCoder nameCoder = new XmlFriendlyNameCoder();
			return (nameCoder.decodeNode("_test"));
		} catch (Exception ex) {
			return ex.toString();
		}
	}

	@Test
	public String test_5() {
		try {
			XmlFriendlyNameCoder nameCoder = new XmlFriendlyNameCoder();
			nameCoder.decodeNode("t__est");
			return (nameCoder.decodeNode("t__est"));
		} catch (Exception ex) {
			return ex.toString();
		}
	}

	/**
	 * @Test public void test_6() { XmlFriendlyNameCoder nameCoder = new
	 *       XmlFriendlyNameCoder(); char data[] = new char[1024 * 1024]; for
	 *       (int i = 1; i < data.length; i++) { data[i] = 'a'; } String d =
	 *       String.valueOf(data); long nanoTime = System.nanoTime();
	 *       assertTrue(nameCoder.decodeNode(d).equals(d)); long simple =
	 *       System.nanoTime() - nanoTime;
	 * 
	 *       data[0] = '_'; d = String.valueOf(data); nanoTime =
	 *       System.nanoTime(); assertTrue(nameCoder.decodeNode(d).equals(d));
	 *       long complex = System.nanoTime() - nanoTime;
	 * 
	 *       assertTrue(complex > simple * 1.6);
	 * 
	 *       nanoTime = System.nanoTime();
	 *       assertTrue(nameCoder.decodeNode(d).equals(d)); long complex2 =
	 *       System.nanoTime() - nanoTime;
	 * 
	 *       assertTrue(complex > complex2 * 3); }
	 */
	public String testCorrectWriting_1() {
		try {

			String xml = "<I_-Node hello='world' a='b' c='d'><empty/></I_-Node>";
			DocumentBuilderFactory documentBuilderFactory = DocumentBuilderFactory.newInstance();
			DocumentBuilder documentBuilder = documentBuilderFactory.newDocumentBuilder();
			ByteArrayInputStream inputStream = new ByteArrayInputStream(xml.getBytes());
			Document document = documentBuilder.parse(inputStream);

			HierarchicalStreamReader xmlReader = new DomReader(document);

			return xmlReader.getNodeName() + xmlReader.getNodeName();
		} catch (Exception ex) {
			return ex.toString();
		}
	}

	public String testErrorWriting_1() {
		try {

			String xml = "<I_a-Node hello='world' a='b' c='d'><empty/></I_a-Node>";
			DocumentBuilderFactory documentBuilderFactory = DocumentBuilderFactory.newInstance();
			DocumentBuilder documentBuilder = documentBuilderFactory.newDocumentBuilder();
			ByteArrayInputStream inputStream = new ByteArrayInputStream(xml.getBytes());
			Document document = documentBuilder.parse(inputStream);

			HierarchicalStreamReader xmlReader = new DomReader(document);

			return xmlReader.getNodeName();
		} catch (Exception ex) {
			return ex.toString();
		}
	}

	public String testCorrectWriting_2() {
		try {

			String xml = "<I__Node hello='world' a='b' c='d'><empty/></I__Node>";
			DocumentBuilderFactory documentBuilderFactory = DocumentBuilderFactory.newInstance();
			DocumentBuilder documentBuilder = documentBuilderFactory.newDocumentBuilder();
			ByteArrayInputStream inputStream = new ByteArrayInputStream(xml.getBytes());
			Document document = documentBuilder.parse(inputStream);

			HierarchicalStreamReader xmlReader = new DomReader(document);

			return xmlReader.getNodeName();
		} catch (Exception ex) {
			return ex.toString();
		}
	}

	// public String testErrorWriting_2() {
	// try {
	//
	// String xml = "<I_a-Node hello='world' a='b' c='d'><empty/></I_a-Node>";
	// DocumentBuilderFactory documentBuilderFactory = DocumentBuilderFactory
	// .newInstance();
	// DocumentBuilder documentBuilder = documentBuilderFactory
	// .newDocumentBuilder();
	// ByteArrayInputStream inputStream = new ByteArrayInputStream(
	// xml.getBytes());
	// Document document = documentBuilder.parse(inputStream);
	//
	// HierarchicalStreamReader xmlReader = new DomReader(document);
	//
	// return xmlReader.getNodeName();
	// } catch (Exception ex) {
	// return ex.toString();
	// }
	// }
	//
	// public String testCorrectWriting_3() {
	// try {
	//
	// String xml = "<I_-Node hello='world' a='b' c='d'><empty/></I_-Node>";
	// DocumentBuilderFactory documentBuilderFactory = DocumentBuilderFactory
	// .newInstance();
	// DocumentBuilder documentBuilder = documentBuilderFactory
	// .newDocumentBuilder();
	// ByteArrayInputStream inputStream = new ByteArrayInputStream(
	// xml.getBytes());
	// Document document = documentBuilder.parse(inputStream);
	//
	// HierarchicalStreamReader xmlReader = new DomReader(document);
	//
	// return xmlReader.getNodeName();
	// } catch (Exception ex) {
	// return ex.toString();
	// }
	// }

	public String testCorrectWriting_4() {
		try {

			String xml = "<aI_-Node hello='world' a='b' c='d'><empty/></aI_-Node>";
			DocumentBuilderFactory documentBuilderFactory = DocumentBuilderFactory.newInstance();
			DocumentBuilder documentBuilder = documentBuilderFactory.newDocumentBuilder();
			ByteArrayInputStream inputStream = new ByteArrayInputStream(xml.getBytes());
			Document document = documentBuilder.parse(inputStream);

			HierarchicalStreamReader xmlReader = new DomReader(document);

			return xmlReader.getNodeName();
		} catch (Exception ex) {
			return ex.toString();
		}
	}

	public String testCorrectWriting_5() {
		try {

			String xml = "<IaNode hello='world' a='b' c='d'><empty/></IaNode>";
			DocumentBuilderFactory documentBuilderFactory = DocumentBuilderFactory.newInstance();
			DocumentBuilder documentBuilder = documentBuilderFactory.newDocumentBuilder();
			ByteArrayInputStream inputStream = new ByteArrayInputStream(xml.getBytes());
			Document document = documentBuilder.parse(inputStream);

			HierarchicalStreamReader xmlReader = new DomReader(document);

			return xmlReader.getNodeName();
		} catch (Exception ex) {
			return ex.toString();
		}
	}

	public String testNew_Killing_Tcs_1() {
		try {

			String dollarReplacement = "_-";
			String escapeCharReplacement = "^-";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			return ncoder.decodeNode("IZ^-Node");
		} catch (Exception ex) {
			return ex.toString();
		}
	}

	public String testNew_Killing_Tcs_2() {
		try {

			String dollarReplacement = "_-";
			String escapeCharReplacement = "^-";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			return ncoder.decodeNode("_-node");
		} catch (Exception ex) {
			return ex.toString();
		}
	}

	public String testNew_Killing_Tcs_3() {
		try {

			String dollarReplacement = "_-";
			String escapeCharReplacement = "^-";
			String name = "_-nodenodenode";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			return ncoder.decodeNode(name);
		} catch (Exception ex) {
			return ex.toString();
		}
	}

	public String testNew_Killing_Tcs_4() {
		try {

			String dollarReplacement = "_-";
			String escapeCharReplacement = "^-";
			String name = "^-nodenodenode";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			return ncoder.decodeNode(name);
		} catch (Exception ex) {
			return ex.toString();
		}
	}

	public String test_emptyString() {
		XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder();
		String decoded = ncoder.decodeNode("");
		String expected = "";

		return decoded;
	}

	@Test
	public String testDecodeNode_escapeChar() {
		try {

			String dollarReplacement = "_-";
			String escapeCharReplacement = "^-";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			String decoded = ncoder.decodeNode("A^-Node");

			String expected = "A_Node";

			String result1 = decoded;

			// for if(s != null) coverage
			decoded = ncoder.decodeNode("A^-Node");
			return decoded + result1;
		} catch (Exception ex) {
			return ex.toString();
		}
	}

	// @Test
	// public void testDecodeNode_noReplacements() {
	//
	// String dollarReplacement = "_-";
	// String escapeCharReplacement = "^_";
	//
	// XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(
	// dollarReplacement, escapeCharReplacement);
	//
	// String decoded = ncoder.decodeNode("Yo");
	// String expected = "Yo";
	//
	// assertTrue(decoded.equals(expected));
	// }

	@Test
	public String testDecodeNode_partialDollarChar() {
		try {

			String dollarReplacement = "_-";
			String escapeCharReplacement = "^_";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			String decoded = ncoder.decodeNode("_a");

			String expected = "_a";

			return decoded;
		} catch (Exception ex) {
			return ex.toString();
		}
	}

	@Test
	public String testDecodeNode_partialEscapeChar() {
		try {

			String dollarReplacement = "_-";
			String escapeCharReplacement = "^_";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			String decoded = ncoder.decodeNode("^a");
			String expected = "^a";

			return decoded;
		} catch (Exception ex) {
			return ex.toString();
		}
	}

	@Test
	public String testDecodeNode_emptyString() {
		try {

			String dollarReplacement = "_-";
			String escapeCharReplacement = "^_";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			String decoded = ncoder.decodeNode("");
			String expected = "";

			return decoded;
		} catch (Exception ex) {
			return ex.toString();
		}
	}

	@Test
	public String testDecodeNode_startsWithDollarReplacement() {
		try {

			String dollarReplacement = "_-";
			String escapeCharReplacement = "^_";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			String decoded = ncoder.decodeNode("_-Hello^_There!");
			String expected = "$Hello_There!";

			return decoded;
		} catch (Exception ex) {
			return ex.toString();
		}
	}

	@Test
	public String testDecodeNode_startsWithEscapeCharReplacement() {
		try {

			String dollarReplacement = "_-";
			String escapeCharReplacement = "^_";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			String decoded = ncoder.decodeNode("^_HowAreYou");
			String expected = "_HowAreYou";

			return decoded;
		} catch (Exception ex) {
			return ex.toString();
		}
	}

	@Test
	public String testDecodeNode_escapeChar1() {
		try {

			String dollarReplacement = "_-";
			String escapeCharReplacement = "^-";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			String decoded = ncoder.decodeNode("A^-Node");

			String expected = "A_Node";

			String result1 = decoded;
			// for if(s != null) coverage
			decoded = ncoder.decodeNode("A^-Node");
			return decoded + result1;
		} catch (Exception ex) {
			return ex.toString();
		}
	}

	// @Test
	// public void testDecodeNode_noReplacements() {
	//
	// String dollarReplacement = "_-";
	// String escapeCharReplacement = "^_";
	//
	// XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(
	// dollarReplacement, escapeCharReplacement);
	//
	// String decoded = ncoder.decodeNode("Yo");
	// String expected = "Yo";
	//
	// assertTrue(decoded.equals(expected));
	// }

	@Test
	public String testDecodeNode_emptyString1() {
		try {

			String dollarReplacement = "_-";
			String escapeCharReplacement = "^_";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			String decoded = ncoder.decodeNode("");
			String expected = "";

			return decoded;
		} catch (Exception ex) {
			return ex.toString();
		}
	}

	@Test
	public String testDecodeNode_startsWithDollarReplacement1() {
		try {

			String dollarReplacement = "_-";
			String escapeCharReplacement = "^_";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			String decoded = ncoder.decodeNode("_-Hello^_There!");
			String expected = "$Hello_There!";

			return decoded;
		} catch (Exception ex) {
			return ex.toString();
		}
	}

	@Test
	public String testDecodeNode_startsWithEscapeCharReplacement1() {
		try {

			String dollarReplacement = "_-";
			String escapeCharReplacement = "^_";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			String decoded = ncoder.decodeNode("^_HowAreYou");
			String expected = "_HowAreYou";

			return decoded;
		} catch (Exception ex) {
			return ex.toString();
		}
	}

	@Test
	public String testDecodeNode_partialDollarChar1() {
		try {

			String dollarReplacement = "_-";
			String escapeCharReplacement = "^_";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			String decoded = ncoder.decodeNode("_a");

			String expected = "_a";

			return decoded;
		} catch (Exception ex) {
			return ex.toString();
		}
	}

	@Test
	public String testDecodeNode_partialEscapeChar1() {
		try {

			String dollarReplacement = "_-";
			String escapeCharReplacement = "^_";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			String decoded = ncoder.decodeNode("^a");
			String expected = "^a";

			return decoded;
		} catch (Exception ex) {
			return ex.toString();
		}
	}

}
