package xcom.thoughtworks.xstream.io.xml;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;

import org.junit.Test;

public class XMLFNCMutationAdeqTS_major {

	@Test
	public void test_1() {
		XmlFriendlyNameCoder nameCoder = new XmlFriendlyNameCoder();
		assertTrue(nameCoder.decodeNode("test").equals("test"));
	}

	@Test
	public void test_2() {
		XmlFriendlyNameCoder nameCoder = new XmlFriendlyNameCoder("_-", "*_");
		assertTrue(nameCoder.decodeNode("t*_est").equals("t_est"));
	}

	@Test
	public void test_3() {
		XmlFriendlyNameCoder nameCoder = new XmlFriendlyNameCoder("_-", "*_");
		assertTrue(nameCoder.decodeNode("_-te*_st").equals("$te_st"));
	}

	@Test
	public void test_4() {
		XmlFriendlyNameCoder nameCoder = new XmlFriendlyNameCoder();
		assertTrue(nameCoder.decodeNode("_test").equals("_test"));
	}

	@Test
	public void test_5() {
		XmlFriendlyNameCoder nameCoder = new XmlFriendlyNameCoder();
		nameCoder.decodeNode("t__est");
		assertTrue(nameCoder.decodeNode("t__est").equals("t_est"));
	}

	/**@Test
	public void test_6() {
		XmlFriendlyNameCoder nameCoder = new XmlFriendlyNameCoder();
		char data[] = new char[1024 * 1024];
		for (int i = 1; i < data.length; i++) {
			data[i] = 'a';
		}
		String d = String.valueOf(data);
		long nanoTime = System.nanoTime();
		assertTrue(nameCoder.decodeNode(d).equals(d));
		long simple = System.nanoTime() - nanoTime;

		data[0] = '_';
		d = String.valueOf(data);
		nanoTime = System.nanoTime();
		assertTrue(nameCoder.decodeNode(d).equals(d));
		long complex = System.nanoTime() - nanoTime;

		assertTrue(complex > simple * 1.6);

		nanoTime = System.nanoTime();
		assertTrue(nameCoder.decodeNode(d).equals(d));
		long complex2 = System.nanoTime() - nanoTime;

		assertTrue(complex > complex2 * 3);
	}*/
}
