package xcom.thoughtworks.xstream.io.xml;

import static org.junit.Assert.assertTrue;
import org.junit.Test;

public class XMLFNCMutationAdeqTs_PIT_allMutops_mujava3 {


	public String testDecodeNode_escapeChar() {
		try {

			String dollarReplacement = "_-";
			String escapeCharReplacement = "^-";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			String decoded = ncoder.decodeNode("A^-Node");

			String expected = "A_Node";

			String result1 = decoded;

			// for if(s != null) coverage
			decoded = ncoder.decodeNode("A^-Node");
			return decoded + result1;
		} catch (Exception ex) {
			return ex.toString();
		}
	}

//	@Test
//	public void testDecodeNode_noReplacements() {
//
//		String dollarReplacement = "_-";
//		String escapeCharReplacement = "^_";
//
//		XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(
//				dollarReplacement, escapeCharReplacement);
//
//		String decoded = ncoder.decodeNode("Yo");
//		String expected = "Yo";
//
//		assertTrue(decoded.equals(expected));
//	}


	public String testDecodeNode_partialDollarChar() {
		try {

			String dollarReplacement = "_-";
			String escapeCharReplacement = "^_";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			String decoded = ncoder.decodeNode("_a");

			String expected = "_a";

			return decoded;
		} catch (Exception ex) {
			return ex.toString();
		}
	}


	public String testDecodeNode_partialEscapeChar() {
		try {

			String dollarReplacement = "_-";
			String escapeCharReplacement = "^_";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			String decoded = ncoder.decodeNode("^a");
			String expected = "^a";

			return decoded;
		} catch (Exception ex) {
			return ex.toString();
		}
	}


	public String testDecodeNode_emptyString() {
		try {

			String dollarReplacement = "_-";
			String escapeCharReplacement = "^_";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			String decoded = ncoder.decodeNode("");
			String expected = "";

			return decoded;
		} catch (Exception ex) {
			return ex.toString();
		}
	}


	public String testDecodeNode_startsWithDollarReplacement() {
		try {

			String dollarReplacement = "_-";
			String escapeCharReplacement = "^_";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			String decoded = ncoder.decodeNode("_-Hello^_There!");
			String expected = "$Hello_There!";

			return decoded;
		} catch (Exception ex) {
			return ex.toString();
		}
	}


	public String testDecodeNode_startsWithEscapeCharReplacement() {
		try {

			String dollarReplacement = "_-";
			String escapeCharReplacement = "^_";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement, escapeCharReplacement);

			String decoded = ncoder.decodeNode("^_HowAreYou");
			String expected = "_HowAreYou";

			return decoded;
		} catch (Exception ex) {
			return ex.toString();
		}
	}

}
