package xcom.thoughtworks.xstream.io.xml;

import java.io.ByteArrayInputStream;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;

import xcom.thoughtworks.xstream.io.HierarchicalStreamReader;

public class XMLFNCMutationAdeqTs_mujava3 {

	public String testCorrectWriting_1() {
		try {

			String xml = "<I_-Node hello='world' a='b' c='d'><empty/></I_-Node>";
			DocumentBuilderFactory documentBuilderFactory = DocumentBuilderFactory
					.newInstance();
			DocumentBuilder documentBuilder = documentBuilderFactory
					.newDocumentBuilder();
			ByteArrayInputStream inputStream = new ByteArrayInputStream(
					xml.getBytes());
			Document document = documentBuilder.parse(inputStream);

			HierarchicalStreamReader xmlReader = new DomReader(document);

			return xmlReader.getNodeName() + xmlReader.getNodeName();
		} catch (Exception ex) {
			return ex.toString();
		}
	}

	public String testErrorWriting_1() {
		try {

			String xml = "<I_a-Node hello='world' a='b' c='d'><empty/></I_a-Node>";
			DocumentBuilderFactory documentBuilderFactory = DocumentBuilderFactory
					.newInstance();
			DocumentBuilder documentBuilder = documentBuilderFactory
					.newDocumentBuilder();
			ByteArrayInputStream inputStream = new ByteArrayInputStream(
					xml.getBytes());
			Document document = documentBuilder.parse(inputStream);

			HierarchicalStreamReader xmlReader = new DomReader(document);

			return xmlReader.getNodeName();
		} catch (Exception ex) {
			return ex.toString();
		}
	}

	public String testCorrectWriting_2() {
		try {

			String xml = "<I__Node hello='world' a='b' c='d'><empty/></I__Node>";
			DocumentBuilderFactory documentBuilderFactory = DocumentBuilderFactory
					.newInstance();
			DocumentBuilder documentBuilder = documentBuilderFactory
					.newDocumentBuilder();
			ByteArrayInputStream inputStream = new ByteArrayInputStream(
					xml.getBytes());
			Document document = documentBuilder.parse(inputStream);

			HierarchicalStreamReader xmlReader = new DomReader(document);

			return xmlReader.getNodeName();
		} catch (Exception ex) {
			return ex.toString();
		}
	}

//	public String testErrorWriting_2() {
//		try {
//
//			String xml = "<I_a-Node hello='world' a='b' c='d'><empty/></I_a-Node>";
//			DocumentBuilderFactory documentBuilderFactory = DocumentBuilderFactory
//					.newInstance();
//			DocumentBuilder documentBuilder = documentBuilderFactory
//					.newDocumentBuilder();
//			ByteArrayInputStream inputStream = new ByteArrayInputStream(
//					xml.getBytes());
//			Document document = documentBuilder.parse(inputStream);
//
//			HierarchicalStreamReader xmlReader = new DomReader(document);
//
//			return xmlReader.getNodeName();
//		} catch (Exception ex) {
//			return ex.toString();
//		}
//	}
//
//	public String testCorrectWriting_3() {
//		try {
//
//			String xml = "<I_-Node hello='world' a='b' c='d'><empty/></I_-Node>";
//			DocumentBuilderFactory documentBuilderFactory = DocumentBuilderFactory
//					.newInstance();
//			DocumentBuilder documentBuilder = documentBuilderFactory
//					.newDocumentBuilder();
//			ByteArrayInputStream inputStream = new ByteArrayInputStream(
//					xml.getBytes());
//			Document document = documentBuilder.parse(inputStream);
//
//			HierarchicalStreamReader xmlReader = new DomReader(document);
//
//			return xmlReader.getNodeName();
//		} catch (Exception ex) {
//			return ex.toString();
//		}
//	}

	public String testCorrectWriting_4() {
		try {

			String xml = "<aI_-Node hello='world' a='b' c='d'><empty/></aI_-Node>";
			DocumentBuilderFactory documentBuilderFactory = DocumentBuilderFactory
					.newInstance();
			DocumentBuilder documentBuilder = documentBuilderFactory
					.newDocumentBuilder();
			ByteArrayInputStream inputStream = new ByteArrayInputStream(
					xml.getBytes());
			Document document = documentBuilder.parse(inputStream);

			HierarchicalStreamReader xmlReader = new DomReader(document);

			return xmlReader.getNodeName();
		} catch (Exception ex) {
			return ex.toString();
		}
	}

	public String testCorrectWriting_5() {
		try {

			String xml = "<IaNode hello='world' a='b' c='d'><empty/></IaNode>";
			DocumentBuilderFactory documentBuilderFactory = DocumentBuilderFactory
					.newInstance();
			DocumentBuilder documentBuilder = documentBuilderFactory
					.newDocumentBuilder();
			ByteArrayInputStream inputStream = new ByteArrayInputStream(
					xml.getBytes());
			Document document = documentBuilder.parse(inputStream);

			HierarchicalStreamReader xmlReader = new DomReader(document);

			return xmlReader.getNodeName();
		} catch (Exception ex) {
			return ex.toString();
		}
	}

	public String testNew_Killing_Tcs_1() {
		try {

			String dollarReplacement = "_-";
			String escapeCharReplacement = "^-";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement,
					escapeCharReplacement);

			return ncoder.decodeNode("IZ^-Node");
		} catch (Exception ex) {
			return ex.toString();
		}
	}

	public String testNew_Killing_Tcs_2() {
		try {

			String dollarReplacement = "_-";
			String escapeCharReplacement = "^-";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement,
					escapeCharReplacement);

			return ncoder.decodeNode("_-node");
		} catch (Exception ex) {
			return ex.toString();
		}
	}

	public String testNew_Killing_Tcs_3() {
		try {

			String dollarReplacement = "_-";
			String escapeCharReplacement = "^-";
			String name = "_-nodenodenode";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement,
					escapeCharReplacement);

			return ncoder.decodeNode(name);
		} catch (Exception ex) {
			return ex.toString();
		}
	}

	public String testNew_Killing_Tcs_4() {
		try {

			String dollarReplacement = "_-";
			String escapeCharReplacement = "^-";
			String name = "^-nodenodenode";

			XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder(dollarReplacement,
					escapeCharReplacement);

			return ncoder.decodeNode(name);
		} catch (Exception ex) {
			return ex.toString();
		}
	}
	
	public String test_emptyString() {
		XmlFriendlyNameCoder ncoder = new XmlFriendlyNameCoder();
		String decoded = ncoder.decodeNode("");
		String expected = "";

		return decoded;
	}
}
